Unit ReInit;

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms;

Procedure ReinitializeForms;
//function LoadNewResourceModule(Locale: LCID): Longint;
Function LoadNewResourceModule(FileName: String): Longint;

Implementation

Type
  TAsInheritedReader = Class(TReader)
  Public
    Procedure ReadPrefix(Var Flags: TFilerFlags; Var AChildPos: Integer); Override;
  End;

Procedure TAsInheritedReader.ReadPrefix(Var Flags: TFilerFlags; Var AChildPos: Integer);
Begin
  Inherited ReadPrefix(Flags, AChildPos);
  Include(Flags, ffInherited);
End;

Function SetResourceHInstance(NewInstance: Longint): Longint;
Var
  CurModule: PLibModule;
Begin
  CurModule := LibModuleList;
  Result    := 0;
  While CurModule <> NIL Do
  Begin
    If CurModule.Instance = HInstance Then
    Begin
      If CurModule.ResInstance <> CurModule.Instance Then
        FreeLibrary(CurModule.ResInstance);
      CurModule.ResInstance := NewInstance;
      Result                := NewInstance;
      Exit;
    End;
    CurModule := CurModule.Next;
  End;
End;

//function LoadNewResourceModule(Locale: LCID): Longint;
Function LoadNewResourceModule(FileName: String): Longint;
Var
//  FileName: array [0..260] of char;
//  P: PChar;
//  LocaleName: array[0..4] of Char;
  NewInst: Longint;
Begin
//  GetModuleFileName(HInstance, FileName, SizeOf(FileName));
//  GetLocaleInfo(Locale, LOCALE_SABBREVLANGNAME, LocaleName, SizeOf(LocaleName));
//  P := PChar(@FileName) + lstrlen(FileName);
//  while (P^ <> '.') and (P <> @FileName) do Dec(P);
//  NewInst := 0;
//  Result := 0;
//  if P <> @FileName then
//  begin
//    Inc(P);
//    if LocaleName[0] <> #0 then
//    begin
//      // Then look for a potential language/country translation
//      lstrcpy(P, LocaleName);
  NewInst := LoadLibraryEx(PChar(FileName), 0, LOAD_LIBRARY_AS_DATAFILE);
  If NewInst = 0 Then
  Begin
        // Finally look for a language only translation
        //        LocaleName[2] := #0;
        //        lstrcpy(P, LocaleName);
    NewInst := LoadLibraryEx(PChar(FileName), 0, LOAD_LIBRARY_AS_DATAFILE);
  End;
//    end;
//  end;
  If NewInst <> 0 Then
    Result := SetResourceHInstance(NewInst)
  Else
    Result := 0;
End;

Function InternalReloadComponentRes(Const ResName: String; HInst: THandle; Var Instance: TComponent): Boolean;
Var
  HRsrc:             THandle;
  ResStream:         TResourceStream;
  AsInheritedReader: TAsInheritedReader;
Begin                   { avoid possible EResNotFound exception }
  If HInst = 0 Then
    HInst := HInstance;
  HRsrc := FindResource(HInst, PChar(ResName), RT_RCDATA);
  Result := HRsrc <> 0;
  If Not Result Then
    Exit;
  ResStream := TResourceStream.Create(HInst, ResName, RT_RCDATA);
  Try
    AsInheritedReader := TAsInheritedReader.Create(ResStream, 4096);
    Try
      Instance := AsInheritedReader.ReadRootComponent(Instance);
    Finally
      AsInheritedReader.Free;
    End;
  Finally
    ResStream.Free;
  End;
  Result := True;
End;

Function ReloadInheritedComponent(Instance: TComponent; RootAncestor: TClass): Boolean;

  Function InitComponent(ClassType: TClass): Boolean;
  Begin
    Result := False;
    If (ClassType = TComponent) Or (ClassType = RootAncestor) Then
      Exit;
    Result := InitComponent(ClassType.ClassParent);
    Result := InternalReloadComponentRes(ClassType.ClassName, FindResourceHInstance(
      FindClassHInstance(ClassType)), Instance) Or Result;
  End;

Begin
  Result := InitComponent(Instance.ClassType);
End;

Procedure ReinitializeForms;
Var
  Count: Integer;
  I:     Integer;
  Form:  TForm;
Begin
  Count := Screen.FormCount;
  For I := 0 To Count - 1 Do
  Begin
    Form := Screen.Forms[I];
    ReloadInheritedComponent(Form, TForm);
  End;
End;

End.
